/// <reference types="node" />
import { AsyncIterableX } from 'ix/asynciterable';
import { Monoid } from 'fp-ts/lib/Monoid';
import { Alternative1 } from 'fp-ts/lib/Alternative';
import { Filterable1 } from 'fp-ts/lib/Filterable';
import { Monad1 } from 'fp-ts/lib/Monad';
import { Predicate } from 'fp-ts/lib/function';
import * as E from 'fp-ts/lib/Either';
import * as O from 'fp-ts/lib/Option';
declare module 'fp-ts/lib/HKT' {
    interface URItoKind<A> {
        AsyncIterableX: AsyncIterableX<A>;
    }
}
export declare const URI = "AsyncIterableX";
export declare type URI = typeof URI;
export declare function getMonoid<A = never>(): Monoid<AsyncIterableX<A>>;
export declare const asyncIterable: Monad1<URI> & Alternative1<URI> & Filterable1<URI>;
declare const alt: <A>(that: () => AsyncIterableX<A>) => (fa: AsyncIterableX<A>) => AsyncIterableX<A>, ap: <A>(fa: AsyncIterableX<A>) => <B>(fab: AsyncIterableX<(a: A) => B>) => AsyncIterableX<B>, apFirst: <B>(fb: AsyncIterableX<B>) => <A>(fa: AsyncIterableX<A>) => AsyncIterableX<A>, apSecond: <B>(fb: AsyncIterableX<B>) => <A>(fa: AsyncIterableX<A>) => AsyncIterableX<B>, chain: <A, B>(f: (a: A) => AsyncIterableX<B>) => (ma: AsyncIterableX<A>) => AsyncIterableX<B>, chainFirst: <A, B>(f: (a: A) => AsyncIterableX<B>) => (ma: AsyncIterableX<A>) => AsyncIterableX<A>, compact: <A>(fa: AsyncIterableX<O.Option<A>>) => AsyncIterableX<A>, filter: {
    <A, B extends A>(refinement: import("fp-ts/lib/function").Refinement<A, B>): (fa: AsyncIterableX<A>) => AsyncIterableX<B>;
    <A>(predicate: Predicate<A>): (fa: AsyncIterableX<A>) => AsyncIterableX<A>;
}, filterMap: <A, B>(f: (a: A) => O.Option<B>) => (fa: AsyncIterableX<A>) => AsyncIterableX<B>, flatten: <A>(mma: AsyncIterableX<AsyncIterableX<A>>) => AsyncIterableX<A>, map: <A, B>(f: (a: A) => B) => (fa: AsyncIterableX<A>) => AsyncIterableX<B>, partition: {
    <A, B extends A>(refinement: import("fp-ts/lib/function").Refinement<A, B>): (fa: AsyncIterableX<A>) => import("fp-ts/lib/Compactable").Separated<AsyncIterableX<A>, AsyncIterableX<B>>;
    <A>(predicate: Predicate<A>): (fa: AsyncIterableX<A>) => import("fp-ts/lib/Compactable").Separated<AsyncIterableX<A>, AsyncIterableX<A>>;
}, partitionMap: <A, B, C>(f: (a: A) => E.Either<B, C>) => (fa: AsyncIterableX<A>) => import("fp-ts/lib/Compactable").Separated<AsyncIterableX<B>, AsyncIterableX<C>>, separate: <A, B>(fa: AsyncIterableX<E.Either<A, B>>) => import("fp-ts/lib/Compactable").Separated<AsyncIterableX<A>, AsyncIterableX<B>>;
export { alt, ap, apFirst, apSecond, chain, chainFirst, compact, filter, filterMap, flatten, map, partition, partitionMap, separate };
export declare const fromNodeStream: <E>(stream: NodeJS.ReadableStream, size: number, onreject: (err: unknown) => E) => AsyncIterableX<E.Either<E, string | Buffer>>;
