import { IterableX } from 'ix/iterable';
import { Monoid } from 'fp-ts/lib/Monoid';
import { Alternative1 } from 'fp-ts/lib/Alternative';
import { Filterable1 } from 'fp-ts/lib/Filterable';
import { Monad1 } from 'fp-ts/lib/Monad';
import { Predicate } from 'fp-ts/lib/function';
import * as E from 'fp-ts/lib/Either';
import * as O from 'fp-ts/lib/Option';
declare module 'fp-ts/lib/HKT' {
    interface URItoKind<A> {
        IterableX: IterableX<A>;
    }
}
export declare const URI = "IterableX";
export declare type URI = typeof URI;
export declare function getMonoid<A = never>(): Monoid<IterableX<A>>;
export declare const iterable: Monad1<URI> & Alternative1<URI> & Filterable1<URI>;
declare const alt: <A>(that: () => IterableX<A>) => (fa: IterableX<A>) => IterableX<A>, ap: <A>(fa: IterableX<A>) => <B>(fab: IterableX<(a: A) => B>) => IterableX<B>, apFirst: <B>(fb: IterableX<B>) => <A>(fa: IterableX<A>) => IterableX<A>, apSecond: <B>(fb: IterableX<B>) => <A>(fa: IterableX<A>) => IterableX<B>, chain: <A, B>(f: (a: A) => IterableX<B>) => (ma: IterableX<A>) => IterableX<B>, chainFirst: <A, B>(f: (a: A) => IterableX<B>) => (ma: IterableX<A>) => IterableX<A>, compact: <A>(fa: IterableX<O.Option<A>>) => IterableX<A>, filter: {
    <A, B extends A>(refinement: import("fp-ts/lib/function").Refinement<A, B>): (fa: IterableX<A>) => IterableX<B>;
    <A>(predicate: Predicate<A>): (fa: IterableX<A>) => IterableX<A>;
}, filterMap: <A, B>(f: (a: A) => O.Option<B>) => (fa: IterableX<A>) => IterableX<B>, flatten: <A>(mma: IterableX<IterableX<A>>) => IterableX<A>, map: <A, B>(f: (a: A) => B) => (fa: IterableX<A>) => IterableX<B>, partition: {
    <A, B extends A>(refinement: import("fp-ts/lib/function").Refinement<A, B>): (fa: IterableX<A>) => import("fp-ts/lib/Compactable").Separated<IterableX<A>, IterableX<B>>;
    <A>(predicate: Predicate<A>): (fa: IterableX<A>) => import("fp-ts/lib/Compactable").Separated<IterableX<A>, IterableX<A>>;
}, partitionMap: <A, B, C>(f: (a: A) => E.Either<B, C>) => (fa: IterableX<A>) => import("fp-ts/lib/Compactable").Separated<IterableX<B>, IterableX<C>>, separate: <A, B>(fa: IterableX<E.Either<A, B>>) => import("fp-ts/lib/Compactable").Separated<IterableX<A>, IterableX<B>>;
export { alt, ap, apFirst, apSecond, chain, chainFirst, compact, filter, filterMap, flatten, map, partition, partitionMap, separate };
